/* This plugins lets you better control HookMOD with admin commands
*/

/* $Id: plugin_hook.sma,v 1.0 2002/08/20
 * Initial Version
 * $
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

/* Access for Hook Commands*/
#define ACCESS_HOOK ACCESS_BAN

new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.50";

public admin_hook(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	
	convert_string(HLCommand,Command,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	if(check_param(Data) == 1 && getvar("DF_hook_on") == 0) {
		exec("DF_hook_on 1",0);
		centersay("HookMOD has been Enabled",18,63,187,239);
		say_command(User,Command,Data,1);
	}
	else if(check_param(Data) == 1 && getvar("DF_hook_on") == 1) {
		selfmessage("HookMOD is already Enabled");
	}
	else if((strcasecmp(Data, "off") == 0) && getvar("DF_hook_on") == 1)
	{
		exec("DF_hook_on 0",0);
		centersay("HookMOD has been Disabled",18,63,187,239);
		say_command(User,Command,Data,1);
	}
	else if((strcasecmp(Data, "off") == 0) && getvar("DF_hook_on") == 0)
	{
		selfmessage("HookMOD is already Disabled");
	}
	else if(getvar("DF_hook_on") == 1)
	{
		selfmessage("HookMOD is Enabled");
		selfmessage("admin_hook <on|off> : lets you turn hookmod on or off");
	}
	else
	{
		selfmessage("HookMOD is Disabled");
		selfmessage("admin_hook <on|off> : lets you turn hookmod on or off");
	}
	
	return PLUGIN_HANDLED;
}

public hook_help(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	
	convert_string(HLCommand,Command,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	if(getvar("DF_hook_on") == 0)
	{
		selfmessage("**** HookMOD is currently Disabled ****");
	}
	else
	{
		selfmessage("**** HookMOD is currently Enabled ****");
		selfmessage("***************************************");
		selfmessage("To use it by pressing <any_key>,");
		selfmessage("type the following into the console:");
		selfmessage("bind <any_key> +hook");
		selfmessage("***************************************");
	}
	
	return PLUGIN_HANDLED;
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	strstripquotes(Data);

	if (strcasestr(Data, "hook") != -1)
	{
		if(getvar("DF_hook_on") == 0)
		{
			say("HookMOD is currently Disabled");
		}
		else
		{
			say("HookMOD is currently Enabled,");
			say("hook_help in console for instructions");
		}
	}

	return PLUGIN_CONTINUE;
}

public plugin_init() {
	plugin_registerinfo("HookMOD Plugin","Allows you to control HookMOD with admin commands",STRING_VERSION);
	plugin_registercmd("admin_hook","admin_hook",ACCESS_HOOK,"admin_hook <on|off> : lets you turn hookmod on or off");
	plugin_registercmd("hook_help","hook_help",ACCESS_ALL,"hook_help : offers some help with HookMOD");
	plugin_registercmd("say","HandleSay",ACCESS_ALL);
	plugin_registerhelp("say",ACCESS_ALL,"say hook: Will give hook status.");
	return PLUGIN_CONTINUE;
}